import 'reflect-metadata'

export const jsonOptionMataDataKey = Symbol('JsonOptions')

export enum JsonOptionType
  {
  Ignore = 0,
  Property = 1,
}

export class JsonOption
{
  constructor(type: JsonOptionType, data: any = null)
  {
    this.type = type
    this.data = data
  }

  type: JsonOptionType
  data: any
}

export function jsonProperty(key: string | number)
{
  return Reflect.metadata(jsonOptionMataDataKey, new JsonOption(JsonOptionType.Property, { key }))
}

export function jsonIgnore()
{
  return Reflect.metadata(jsonOptionMataDataKey, new JsonOption(JsonOptionType.Ignore))
}
