import 'reflect-metadata'

const displayMetadataKey = Symbol('display')

export function display(
  name: string,
  group: string = '',
  type: string = 'color',
)
{
  return Reflect.metadata(displayMetadataKey, {
    name,
    group,
    type,
  })
}

export function getDisplayInfo(target: any)
{
  let keys = Object.getOwnPropertyNames(target)
  let list = []
  keys.forEach((key) =>
  {
    let info = <{ name: string; group: string; type: number }>(
            Reflect.getMetadata(displayMetadataKey, target, key)
        )
    if (info)
    {
      info
      list.push({
        prop: key,
        name: info.name,
        group: info.group,
        type: info.type,
      })
    }
  })
  return list
}
