export async function readText(file: Blob, encoding?: string): Promise<string>
{
  return new Promise((resolve) =>
  {
    let fileReader = new FileReader()
    fileReader.onload = function (e)
    {
      resolve(<string> this.result)
    }
    fileReader.readAsText(file, encoding)
  })
}

export function getFileExt(name: string)
{
  let index = name.lastIndexOf('.')
  if (index != -1)
  {
    return name.substring(index + 1, name.length)
  }
  return null
}
